clear all; clc; close all;

  load variables_p1.mat
  load variables_p2.mat
  load variables_p3.mat

espacios=40;
diferente=3;

experimento="Experiment 4";
%valor1=10;valor2=6;
%i=find(velocidad2_pro_p1>valor1 | velocidad2_pro_p1<valor2);

%i=[3:1:202];%experimento 1
%i=[3:1:202];%experimento 2
%i=[3:1:202];%experimento 3
%i=[3:1:202];%experimento 4
i=[3:1:202];

v_pro_p1=velocidad2_pro_p1(i);
d_pro_p1=densidad2_pro_p1(i);
f_pro_p1=flujo2_pro_p1(i);

v_pro_p2=velocidad2_pro_p2(i);
d_pro_p2=densidad2_pro_p2(i);
f_pro_p2=flujo2_pro_p2(i);

v_pro_p3=velocidad2_pro_p3(i);
d_pro_p3=densidad2_pro_p3(i);
f_pro_p3=flujo2_pro_p3(i);


for i=1:1:3
    
    if i==1
    velocidad=velocidad2_pro_p1;flujo=flujo2_pro_p1;densidad=densidad2_pro_p1;
    color="k";mark=".";

    p1_dv=polyfit(d_pro_p1,v_pro_p1,1);
    p1_vf=polyfit(v_pro_p1,f_pro_p1,2);
    p1_df=polyfit(d_pro_p1,f_pro_p1,2);

    min1_d=min(d_pro_p1);max1_d=max(d_pro_p1);
    min1_f=min(f_pro_p1);max1_f=max(f_pro_p1);
    min1_v=min(v_pro_p1);max1_v=max(v_pro_p1);

    end

    if i==2
    velocidad=velocidad2_pro_p2;flujo=flujo2_pro_p2;densidad=densidad2_pro_p2;
    color="b";mark="o";
    
    p2_dv=polyfit(d_pro_p2,v_pro_p2,1);
    p2_vf=polyfit(v_pro_p2,f_pro_p2,2);
    p2_df=polyfit(d_pro_p2,f_pro_p2,2);

    min2_d=min(d_pro_p2);max2_d=max(d_pro_p2);
    min2_f=min(f_pro_p2);max2_f=max(f_pro_p2);
    min2_v=min(v_pro_p2);max2_v=max(v_pro_p2);

    end

    if i==3
    velocidad=velocidad2_pro_p3;flujo=flujo2_pro_p3;densidad=densidad2_pro_p3;
    color="r";mark="+";

    p3_dv=polyfit(d_pro_p3,v_pro_p3,1);
    p3_vf=polyfit(v_pro_p3,f_pro_p3,2);
    p3_df=polyfit(d_pro_p3,f_pro_p3,2);
    
    min3_d=min(d_pro_p3);max3_d=max(d_pro_p3);
    min3_f=min(f_pro_p3);max3_f=max(f_pro_p3);
    min3_v=min(v_pro_p3);max3_v=max(v_pro_p3);

    end

    l1=1;l2=espacios;
    
    for j=1:1:diferente
        if j==2
            l1=l2+1;l2=l2+espacios;
        end
        if j==3
            l1=l2+1;l2=length(velocidad(:,1));
        end
    
    r{i,1}(1,j)=mean(velocidad(l1:l2,1));
    r{i,1}(2,j)=std(velocidad(l1:l2,1));

    r{i,1}(3,j)=mean(densidad(l1:l2,1));
    r{i,1}(4,j)=std(densidad(l1:l2,1));
    
    r{i,1}(5,j)=mean(flujo(l1:l2,1));
    r{i,1}(6,j)=std(flujo(l1:l2,1));

    end

    figure(1);hold on;grid on;
    plot(densidad,velocidad,color+mark);
    xlabel('Network density (veh/m)');ylabel('Network speed (m/s)');title(experimento);
    figure(2);hold on;
    plot(velocidad,flujo,color+mark);
    xlabel('Network speed (m/s)');ylabel('Network flow (veh/s)');title(experimento);
    figure(3);hold on;
    plot(densidad,flujo,color+mark);
    xlabel('Network density (veh/m)');ylabel('Network flow (veh/s)');title(experimento);

tiempo=[1:1:length( velocidad(:,1) )]';

figure(4);hold on;grid on;
%axis([0 max(tiempo) min(velocidad) max(velocidad)])
plot(tiempo,velocidad,color+mark);
xlabel('Period index');ylabel('Network speed (m/s)');title(experimento);
figure(5);hold on;grid on;
plot(tiempo,densidad,color+mark);
xlabel('Period index');ylabel('Network density (veh/m)');title(experimento);
figure(6);hold on;grid on;
plot(tiempo,flujo,color+mark);
xlabel('Period index');ylabel('Network flow (veh/s)');title(experimento);

end

%%%%%%%%%%%%%%%%%%
figure(1);hold on;grid on;

inc=(max1_d-min1_d)/50;x=[min1_d:inc:max1_d]';y1 = polyval(p1_dv,x);
indice1=find(y1>=0);x1=x(indice1,1);y1 = y1(indice1,1);plot(x1,y1,'g.');

inc=(max2_d-min2_d)/50;x=[min2_d:inc:max2_d]';y2 = polyval(p2_dv,x);
indice2=find(y2>=0);x2=x(indice2,1);y2=y2(indice2,1);plot(x2,y2,'go');

inc=(max3_d-min3_d)/50;x=[min3_d:inc:max3_d]';y3 = polyval(p3_dv,x);
indice3=find(y3>=0);x3=x(indice3,1);y3=y3(indice3,1);plot(x3,y3,'g+');

mi=max([x1(1,1) x2(1,1)]);ma=min([x1(end,1) x2(end,1)]);

j=0;densidad=[densidad2_pro_p1; densidad2_pro_p2];
for i=1:1:length(densidad(:,1))

    if (densidad(i,1)>=mi && densidad(i,1)<=ma)
        j=j+1;
        mod1=polyval(p1_dv,densidad(i,1));
        mod2=polyval(p2_dv,densidad(i,1));
        e_y1y2(j,1)=abs(  mod1-mod2  );
    end

end
E_y1y2_DV= mean(e_y1y2) 
clear e_y1y2


mi=max([x2(1,1) x3(1,1)]);ma=min([x2(end,1) x3(end,1)]);

j=0;densidad=[densidad2_pro_p2; densidad2_pro_p3];
for i=1:1:length(densidad(:,1))

    if (densidad(i,1)>=mi && densidad(i,1)<=ma)
        j=j+1;
        mod3=polyval(p3_dv,densidad(i,1));
        mod2=polyval(p2_dv,densidad(i,1));
        e_y2y3(j,1)=abs( mod3-mod2 );
    end

end
E_y2y3_DV=mean(e_y2y3)
clear e_y2y3


mi=max([x1(1,1) x3(1,1)]);ma=min([x1(end,1) x3(end,1)]);

j=0;densidad=[densidad2_pro_p1; densidad2_pro_p3];
for i=1:1:length(densidad(:,1))

    if (densidad(i,1)>=mi && densidad(i,1)<=ma)
        j=j+1;
        mod3=polyval(p3_dv,densidad(i,1));
        mod1=polyval(p1_dv,densidad(i,1));
        e_y1y3(j,1)=abs( mod1-mod3 );
    end

end
E_y1y3_DV=mean(e_y1y3)
clear e_y1y3
%%%%%%%%%%%%%
figure(2);hold on;grid on;
inc=(max1_v-min1_v)/50;x=[min1_v:inc:max1_v]';y1=polyval(p1_vf,x);
indice1=find(y1>=0);x1=x(indice1,1);y1 = y1(indice1,1);plot(x1,y1,'g.');

inc=(max2_v-min2_v)/50;x=[min2_v:inc:max2_v]';y2=polyval(p2_vf,x);
indice2=find(y2>=0);x2=x(indice2,1);y2=y2(indice2,1);plot(x2,y2,'go');

inc=(max3_v-min3_v)/50;x=[min3_v:inc:max3_v]';y3=polyval(p3_vf,x);
indice3=find(y3>=0);x3=x(indice3,1);y3=y3(indice3,1);plot(x3,y3,'g+');
% 
% mi=max([x1(1,1) x2(1,1)]);ma=min([x1(end,1) x2(end,1)]);
% 
% j=0;velocidad=[velocidad2_pro_p1; velocidad2_pro_p2];
% for i=1:1:length(velocidad(:,1))
% 
%     if (velocidad(i,1)>=mi && velocidad(i,1)<=ma)
%     j=j+1;
%     mod1 = polyval(p1_vf,velocidad(i,1));
%     mod2 = polyval(p2_vf,velocidad(i,1));
%     e_y1y2(j,1)=abs(mod1-mod2);
%     end
% 
% end
% 
% E_y1y2_VF=mean(e_y1y2)
% clear e_y1y2 
% 
% mi=max([x2(1,1) x3(1,1)]);ma=min([x2(end,1) x3(end,1)]);
% 
% j=0;velocidad=[velocidad2_pro_p2; velocidad2_pro_p3];
% for i=1:1:length(velocidad(:,1))
% 
%     if (velocidad(i,1)>=mi && velocidad(i,1)<=ma)
%     j=j+1;
%     mod2 = polyval(p2_vf,velocidad(i,1));
%     mod3 = polyval(p3_vf,velocidad(i,1));
%     e_y2y3(j,1)=abs(mod3-mod2);
%     end
% 
% end
% E_y2y3_VF=mean(e_y2y3)
% clear e_y2y3 

%%%%%%
figure(3);hold on;grid on;

inc=(max1_d-min1_d)/50;x=[min1_d:inc:max1_d]';y1 = polyval(p1_df,x);
indice1=find(y1>=0);x1=x(indice1,1);y1 = y1(indice1,1);plot(x1,y1,'g.');
s1_capacidad=max(y1);
ind=find(y1==s1_capacidad);
s1_critical=x1(ind,1);
num2str(s1_capacidad)
num2str(s1_critical)

inc=(max2_d-min2_d)/50;x=[min2_d:inc:max2_d]';y2 = polyval(p2_df,x);
indice2=find(y2>=0);x2=x(indice2,1);y2=y2(indice2,1);plot(x2,y2,'go');
s2_capacidad=max(y2);
ind=find(y2==s2_capacidad);
s2_critical=x2(ind,1);
num2str(s2_capacidad)
num2str(s2_critical)

inc=(max3_d-min3_d)/50;x=[min3_d:inc:max3_d]';y3 = polyval(p3_df,x);
indice3=find(y3>=0);x3=x(indice3,1);y3=y3(indice3,1);plot(x3,y3,'g+');
s3_capacidad=max(y3);
ind=find(y3==s3_capacidad);
s3_critical=x3(ind,1);
num2str(s3_capacidad)
num2str(s3_critical)

% s1_s2_capacidad=abs(s1_capacidad-s2_capacidad)
% s2_s3_capacidad=abs(s2_capacidad-s3_capacidad)
% s1_s3_capacidad=abs(s1_capacidad-s3_capacidad)
% 
% s1_s2_critical=abs(s1_critical-s2_critical)
% s2_s3_critical=abs(s2_critical-s3_critical)
% s1_s3_critical=abs(s1_critical-s3_critical)

% mi=max([x1(1,1) x2(1,1)]);ma=min([x1(end,1) x2(end,1)]);
% 
% j=0;densidad=[densidad2_pro_p1; densidad2_pro_p2];
% for i=1:1:length(densidad(:,1))
%     if (densidad(i,1)>=mi && densidad(i,1)<=ma)
%     j=j+1;
%     mod1 = polyval(p1_df,densidad(i,1));
%     mod2 = polyval(p2_df,densidad(i,1));
%     e_y1y2(j,1)=abs(mod1-mod2);
% 
%     end
% end
% E_y1y2_DF=mean(e_y1y2)
% clear e_y1y2 
% 
% mi=max([x2(1,1) x3(1,1)]);ma=min([x2(end,1) x3(end,1)]);
% 
% j=0;densidad=[densidad2_pro_p2; densidad2_pro_p3];
% for i=1:1:length(densidad(:,1))
%     if (densidad(i,1)>=mi && densidad(i,1)<=ma)
%     j=j+1;
%     mod2 = polyval(p2_df,densidad(i,1));
%     mod3 = polyval(p3_df,densidad(i,1));
%     e_y2y3(j,1)=abs(mod3-mod2);
% 
%     end
% end
% E_y2y3_DF=mean(e_y2y3)
% clear e_y2y3 
%%%%%%
figure(1);grid on;
legend('Observed S1','Observed S2','Observed S3','Modeled S1','Modeled S2','Modeled S3')
figure(2);grid on;
legend('Observed S1','Observed S2','Observed S3','Modeled S1','Modeled S2','Modeled S3')
figure(3);grid on;
legend('Observed S1','Observed S2','Observed S3','Modeled S1','Modeled S2','Modeled S3')

figure(4);
legend('Simulation 1','Simulation 2','Simulation 3')
figure(5);
legend('Simulation 1','Simulation 2','Simulation 3')
figure(6);
legend('Simulation 1','Simulation 2','Simulation 3')


